
<!DOCTYPE html>
<html>
<head>
    <style> 
        body { margin: 0; }
        #globeViz { width: 100vw; height: 100vh; }
    </style>

    <script src="https://unpkg.com/three"></script>
    <script src="https://unpkg.com/topojson-client@3"></script>
    <script src="https://unpkg.com/globe.gl"></script>
</head>

<body>
  <div id="globeViz"></div>
  <script>

	const world = Globe()(document.getElementById('globeViz'))
		.backgroundColor('rgba(255, 255, 255, 1)')
		.showGlobe(true)
		.showAtmosphere(false);

  const now_utc_unix = Math.floor((new Date().getTime())/1000);
  
  
	const globeMaterial = world.globeMaterial();
	globeMaterial.specular = new THREE.Color('grey');
	globeMaterial.color.set(0xA2A9F8);
	globeMaterial.flatshading = false;
	const max_alt = 6000;
	const min_alt = 50;
	const max_scale = 1.0;
	const min_scale = 0.05;
  const radius_past = 0.35;
  const radius_min = 0.80;
  const radius_max = 2.80;
  const seven_days_seconds = 3600*24*7;


	// Add Auto-Rotation
	world.controls().autoRotate = true;
	world.controls().autoRotateSpeed = 0.15; 

  // --- Fetch data in parallel
	Promise.all([
		fetch('./data/land-110m.json').then(res => res.json()),
		fetch('./data/cdm-v0.json').then(res => res.json())
	]).then(([land, cdms]) => {
		world
			.polygonsData(topojson.feature(land, land.objects.land).features)
			.polygonCapMaterial(new THREE.MeshLambertMaterial({ color: 'rgba(139, 149, 246, 1)', side: THREE.DoubleSide }))
			.polygonSideColor(() => 'rgba(255, 255, 255, 1)');

		// Prepare Data
    const simulated_cdms = cdms.map((d) => ({
      ...d,
      tca: now_utc_unix + 3600 * [-10, 1, 2, 4, 6,
        12, 24, 72, 144, 192][Math.round(Math.random() * 9)]
    }));
    
 
		const prepared_data = simulated_cdms.map((d) => ({
      ...d,
			alt: (((d.alt - min_alt ) * (max_scale - min_scale))/(max_alt - min_alt)) + min_scale,
			
			color:(d.pc < 0.3) ? 'rgba(255, 0, 0, 1)':
				   (d.pc < 0.6) ?'rgba(0, 255, 0, 1)':
				   'rgba(0, 0, 255, 1)',
				  
			//color: 'rgba(255, 149, 246, 1)',
			
      radius: (d.tca < now_utc_unix) ? radius_past : 
        (d.tca > now_utc_unix + seven_days_seconds) ? radius_min :
          radius_max - (
            (d.tca - now_utc_unix) * (radius_max - radius_min)
          ) / (seven_days_seconds),
			name: 'cdm_info'
		}));     

		// Add spikes to the globe
		world.pointsData(prepared_data)
			.pointAltitude("alt")
			.pointColor("color")
			.pointOfView({altitude: 3.5})
			.pointsMerge(false)
			.pointRadius("radius")
			.onPointClick((a,b,c)=>{
				alert("on click");
				console.log(a);
				console.log(b);
				console.log(c);
				});
	});
    </script>
</body>
</html>
